{ qfaeF̃RgXg␳gpāAF̕␳vOł
@K}l̕ύX́AXN[o[ōs܂}

unit RGBGammaMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ExtDlgs, System.Types, System.UITypes,
  Math;

type
  TTempArray = array[0..255] of Byte;          // ev[gpz

  TForm1 = class(TForm)
    FileOpen: TButton;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    FileSaveBtn: TButton;
    RedScrollBar: TScrollBar;
    GreenScrollBar: TScrollBar;
    BlueScrollBar: TScrollBar;
    RedLabel: TLabel;
    GreenLabel: TLabel;
    BlueLabel: TLabel;
    GammaLabel: TLabel;
    RedEdit: TEdit;
    GreenEdit: TEdit;
    BlueEdit: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure RedScrollBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure BlueScrollBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure GreenScrollBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
  private
    { Private 錾 }
    function  GammaTemplate(Gamma: Double): TTempArray;   // GammaTemplatef[^[쐬
    procedure GammaImage;                                 // Gamma␳摜\
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

type
  TPrgbarry = array[0..0] of Trgbtriple;      // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray  = ^TPrgbarry;                    // |C^[
                                              // z̃|C^[KvȂȂ̂ŁA1 [0..0]Ŗ肠܂B

implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHW   = 384;                              // \gTCY


var
  InBitmap        : TBitmap;                    // rbg}bv
  OutBitmap       : TBitmap;
  GHeight, GWidth : integer;                    // \[X摜TCY
  Vrect           : Trect;                      // \g
  IHeight, IWidth : Integer;                    // \TCY

  RGamma          : Double;                     // ԃK}l
  GGamma          : Double;                     // ΃K}l
  BGamma          : Double;                     // K}l

  RGTemp          : TTempArray;                 // Red   K}ev[gpz@
  GGTemp          : TTempArray;                 // Green K}ev[gpz  
  BGTemp          : TTempArray;                 // Blue  K}ev[gpz  

// Gamma␳摜\
procedure TForm1.GammaImage;
var
  Pin     :   Prgbarray;
  Pout    :   Prgbarray;
  II, JJ  :   Integer;
begin
  for II := 0 to Gheight - 1 do begin
    Pin   := InBitmap.ScanLine[II];                           // C̐擪|C^擾
    Pout  := OutBitmap.ScanLine[II];
    for JJ := 0 to GWidth - 1 do begin
      Pout[JJ].rgbtBlue   := BGTemp[Pin[JJ].rgbtBlue];        // ev[gl֕ϊ
      Pout[JJ].rgbtGreen  := GGTemp[Pin[JJ].rgbtGreen];
      Pout[JJ].rgbtRed    := RGTemp[Pin[JJ].rgbtRed];
    end;
  end;
  Image1.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

// ev[gf[^[̐ݒ
function TForm1.GammaTemplate(Gamma: Double): TTempArray;     // GammaTemplatef[^[쐬
var
  II : Integer;
begin
  for II := 0 to 255 do begin                                 // K}l0̌vZ͏oȂ̂Ńev[g[ɐݒ
    if Gamma = 0 then Result[II] := 0
    else
      Result[II] := Round(255 * Power(II / 255, 1 / Gamma));  // ev[g̍쐬
  end;
end;

// XN[
procedure TForm1.RedScrollBarScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  RGamma := ScrollPos / 20;
  RedEdit.Text := floatTostr(RGamma);
  RGTemp := GammaTemplate(RGamma);
  GammaImage;                             // Gamma␳摜\
end;

procedure TForm1.GreenScrollBarScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  GGamma := ScrollPos / 20;
  GreenEdit.Text := floatTostr(GGamma);
  GGTemp := GammaTemplate(GGamma);
  GammaImage;                             // Gamma␳摜\
end;

procedure TForm1.BlueScrollBarScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  BGamma := ScrollPos / 20;
  BlueEdit.Text := floatTostr(BGamma);
  BGTemp := GammaTemplate(BGamma);
  GammaImage;                             // Gamma␳摜\
end;

// t@C̃I[v@WIC@t@C̎ނ̂Ŏgp
procedure TForm1.FileOpenClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  FileSaveBtn.Enabled   := False;
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        IWidth  := ImageHW;                                   // o͐C[W1̕
        IHeight := ImageHW;                                   // o͐C[W1̍
        if GHeight <= GWidth then                             // cɂo̓TCYݒ
          IHeight := Round(IWidth * GHeight / GWidth)
        else
          IWidth := Round(IHeight * GWidth / GHeight);
        Image1.Width := IWidth;
        Image1.Height:= IHeight;
        Image1.Picture.Bitmap.SetSize(IWidth, IHeight);       // \prbg}bvTCY̐ݒ
        VRect := Rect(0, 0, IWidth, IHeight);                 // o͘gݒ
        Image1.Canvas.StretchDraw(VRect, WIC);                // o͘gɕϔ{o
        InBitmap.Width    := GWidth;
        InBitmap.Height   := GHeight;
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
        OutBitmap.Width := GWidth;
        OutBitmap.Height:= GHeight;
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else Exit;
  RedScrollBar.Enabled    := True;
  GreenScrollBar.Enabled  := True;
  BlueScrollBar.Enabled   := True;
  FileSaveBtn.Enabled     := True;
end;

// t@C̃I[v
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                             // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                 // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                               // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');    // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');    // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');    // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');    // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');    // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');    // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                          // gqo
  if not WFormatSet then begin                                              // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                       // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                           // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                 // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                  // TWicImage
  try
    WIC.Assign(OutBitmap);                                                  // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                                // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                  // t@C̏o
  finally                                                                   // XE3,XE4̏ꍇ̓J}␳QƂĂ
    WIC.Free;                                                               // TWicImage
  end;
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  FileSaveBtn.Enabled   := False;
  RedScrollBar.Enabled    := False;
  GreenScrollBar.Enabled  := False;
  BlueScrollBar.Enabled   := False;
  Image1.Width  := ImageHW;
  Image1.Height := ImageHW;
  InBitmap      := TBitmap.Create;        // ͉摜p
  OutBitmap     := TBitmap.Create;        // 24rbgo͗p
  InBitmap.PixelFormat    := pf24bit;     // 24rbgJ[ɐݒ
  OutBitmap.PixelFormat   := pf24bit;     // 24rbgJ[ɐݒ
  RGTemp := GammaTemplate(1);             // ԃev[gݒ
  GGTemp := GammaTemplate(1);             // ΃ev[gݒ
  BGTemp := GammaTemplate(1);             // v[gݒ
end;

// rbg}bv̉@
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
end;

end.
